﻿#targetengine "AddInList" 
 
/* 
Динамическое изменение выпадающего списка
Функция getList (list, drop) сперва удаляет все строки выпадающего списка drop, а потом помещает в него содержимое массива list.
Это позволяет изменять длину выпадающего списка в сторону увеличения и уменьшения.
Вот как это работает:
=  при каждом нажатии на "Добавить строку с временем нажатия кнопки" в конец массива list добавляется строка с временем нажатия на эту кнопку.
= кнопка "Удалить выбранную строку из выпадающего списка": считывается индекс выбранной строки выпадающего списка, 
    сдвигается вверх часть массива list под элементом с индексом выбранной строки,
   в результате на месте выбранной строки будет тот элемент, что до этого стоял под ней. И затем удаляется последний объект массива.
В обоих случаях использования кнопок функция getList обновит выпадающий список, и он всегда будет соответствовать текущему содержимому массива list.

--------
Михаил Иванюшин  |  dotextok@gmail.com  |  dotextok.ru
*/

var list = ["утро", "день", "вечер", "ночь"];

var w = new Window ("dialog");
w.alignChildren = ["fill", "fill"];
var dropdown = w.add ("dropdownlist"); // выпадающий список. Вначале он пустой.
getList (list, dropdown); // теперь выпадающий список показывает стартовое содержимое массива list[]
dropdown.selection = 0; // при запуске выбрана первая строка списка
var adItem = w.add("button", undefined, "Добавить строку с временем нажатия кнопки");
var delItem = w.add("button", undefined, "Удалить выбранную строку из выпадающего списка"); 
///
adItem.onClick = function() { // adItem.onClick
var theDate = new Date;
var hour = theDate.getHours();
if (hour <10) hour = "0" + hour;
var minute = theDate.getMinutes();
if (minute <10) minute = "0" + minute;
var seconde = theDate.getSeconds();
if (seconde <10) seconde = "0" + seconde;
list.push(hour + ":" + minute + ":" + seconde); // строка с временем нажатия на кнопку "Добавить строку с временем нажатия кнопки" добавлена в конец массива list[].
//list.unshift(hour + ":" + minute + ":" + seconde); // строка с временем нажатия на кнопку "Добавить строку с временем нажатия кнопки" добавлена в начало массива list[].
getList (list, dropdown); // обновили выпадающий список после добавления новой строки в массив
return;
} // adItem.onClick   
///
delItem.onClick = function() { // delItem.onClick
var selIndex = dropdown.selection.index; // индекс выбранной строки выпадающего списка
for (i = selIndex+1; i < list.length; i++) { list[i-1] = list[i]; } // часть массива list[] под элементом с индексом выбранной строки подняли на одну позицию вверх...
list.pop(); // .. и убрали последний элемент массива
getList (list, dropdown);  // обновили выпадающий список после удаления выбранной строки
} // delItem.onClick
///
function getList (list, drop) { // getList  
drop.removeAll(); // обнуляем текущий выпадающий список...
for (i = 0; i < list.length; i++) { drop.add("item", list[i]); } // ... и формируем его заново
drop.selection = list.length-1; // выбрана последняя строка нового списка
return;
} // getList
///
w.show ();